| base-3.0.2.0: Basic libraries | Source code | Contents | Index

Data.STRef

Portability | non-portable (uses Control.Monad.ST)
Stability | experimental
Maintainer | libraries@haskell.org

Contents

STRefs

Description
Mutable references in the (strict) ST monad.
Synopsis

data STRef s a
newSTRef :: a -> ST s (STRef s a)
readSTRef :: STRef s a -> ST s a
writeSTRef :: STRef s a -> a -> ST s ()
modifySTRef :: STRef s a -> (a -> a) -> ST s ()

STRefs

data STRef s a | Source

a value of type `STRef s a` is a mutable variable in state thread `s`, containing a value of type `a`
Instances

Typeable2 STRef
Eq (STRef s a)

newSTRef :: a -> ST s (STRef s a) | Source

Build a new `STRef` in the current state thread

readSTRef :: STRef s a -> ST s a | Source

Read the value of an `STRef`

writeSTRef :: STRef s a -> a -> ST s () | Source

Write a new value into an `STRef`

modifySTRef :: STRef s a -> (a -> a) -> ST s () | Source

Mutate the contents of an `STRef`
Produced by Haddock version 0.9